"use strict";
/**
 * @module diffusion.clients
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Enum containing possible Address types.
 */
var AddressType;
(function (AddressType) {
    /**
     * The address is a standard global internet address
     */
    AddressType[AddressType["GLOBAL"] = 1] = "GLOBAL";
    /**
     * The address is a site local address. The address is part of the IP subset that is reserved for private networks.
     */
    AddressType[AddressType["LOCAL"] = 2] = "LOCAL";
    /**
     * The address is assigned to the server loopback interface
     */
    AddressType[AddressType["LOOPBACK"] = 3] = "LOOPBACK";
    /**
     * The address type is unknown
     */
    AddressType[AddressType["UNKNOWN"] = 4] = "UNKNOWN";
})(AddressType = exports.AddressType || (exports.AddressType = {}));
