"use strict";
/**
 * @module Services.Client
 */
Object.defineProperty(exports, "__esModule", { value: true });
var Codec = require("io/codec");
var BEES = require("serialisers/byte-encoded-enum-serialiser");
var client_summary_1 = require("../../../client/client-summary");
/**
 * Read a {@link ClientSummary} from the stream
 *
 * @param bis  the input stream
 * @return     the {@link ClientSummary} that was read
 */
function read(bis) {
    var principal = Codec.readString(bis);
    var clientType = BEES.read(bis, client_summary_1.ClientType);
    var transportType = BEES.read(bis, client_summary_1.TransportType);
    return {
        principal: principal,
        clientType: clientType,
        transportType: transportType
    };
}
exports.read = read;
