"use strict";
/**
 * @module Services.FetchJMXValues
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Codec = require("io/codec");
var serialiser_1 = require("serialisers/serialiser");
var jmx_object_names_1 = require("./jmx-object-names");
/**
 * Serialiser for {@link JMXObjectNames}
 */
var JMXObjectNamesSerialiserClass = /** @class */ (function (_super) {
    __extends(JMXObjectNamesSerialiserClass, _super);
    function JMXObjectNamesSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link JMXObjectNames} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link JMXObjectNames} that was read
     */
    JMXObjectNamesSerialiserClass.prototype.read = function (bis) {
        var names = Codec.readCollection(bis, Codec.readString);
        return new jmx_object_names_1.JMXObjectNames(names);
    };
    /**
     * Write a {@link JMXObjectNames} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link JMXObjectNames} to be written
     */
    JMXObjectNamesSerialiserClass.prototype.write = function (bos, value) {
        Codec.writeCollection(bos, value.names, Codec.writeString);
    };
    return JMXObjectNamesSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.JMXObjectNamesSerialiserClass = JMXObjectNamesSerialiserClass;
/**
 * The singleton
 */ // tslint:disable-next-line:variable-name
exports.JMXObjectNamesSerialiser = new JMXObjectNamesSerialiserClass();
