"use strict";
/**
 * @module Services.Fetch
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var conversation_id_serialiser_1 = require("conversation/conversation-id-serialiser");
var serialiser_1 = require("serialisers/serialiser");
var topic_selector_serialiser_1 = require("topics/topic-selector-serialiser");
var fetch_request_1 = require("./fetch-request");
/**
 * Serialiser for {@link FetchRequest}
 */
var FetchRequestSerialiserClass = /** @class */ (function (_super) {
    __extends(FetchRequestSerialiserClass, _super);
    function FetchRequestSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link FetchRequest} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link FetchRequest} that was read
     */
    FetchRequestSerialiserClass.prototype.read = function (bis) {
        var selector = topic_selector_serialiser_1.TopicSelectorSerialiser.read(bis);
        var cid = conversation_id_serialiser_1.CIDSerialiser.read(bis);
        return new fetch_request_1.FetchRequest(cid, selector);
    };
    /**
     * Write a {@link FetchRequest} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link FetchRequest} to be written
     */
    FetchRequestSerialiserClass.prototype.write = function (bos, value) {
        topic_selector_serialiser_1.TopicSelectorSerialiser.write(bos, value.selector);
        conversation_id_serialiser_1.CIDSerialiser.write(bos, value.cid);
    };
    return FetchRequestSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.FetchRequestSerialiserClass = FetchRequestSerialiserClass;
/**
 * The {@link FetchRequestSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.FetchRequestSerialiser = new FetchRequestSerialiserClass();
