"use strict";
/**
 * @module Services.MetricCollectors
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Codec = require("io/codec");
var serialiser_1 = require("serialisers/serialiser");
/**
 * Serialiser for metric collector names.
 */
var MetricCollectorNameSerialiserClass = /** @class */ (function (_super) {
    __extends(MetricCollectorNameSerialiserClass, _super);
    function MetricCollectorNameSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a metric collector name from the stream
     *
     * @param bis  the input stream
     * @return     the string that was read
     */
    MetricCollectorNameSerialiserClass.prototype.read = function (bis) {
        return Codec.readString(bis);
    };
    /**
     * Write a metric collector name to the stream
     *
     * @param bos    the output stream
     * @param value  the string to be written
     */
    MetricCollectorNameSerialiserClass.prototype.write = function (bos, value) {
        Codec.writeString(bos, value);
    };
    return MetricCollectorNameSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.MetricCollectorNameSerialiserClass = MetricCollectorNameSerialiserClass;
/**
 * The singleton
 */ // tslint:disable-next-line:variable-name
exports.MetricCollectorNameSerialiser = new MetricCollectorNameSerialiserClass();
