"use strict";
/**
 * @module Services.Security
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable:max-line-length */
var conversation_id_serialiser_1 = require("conversation/conversation-id-serialiser");
var serialiser_1 = require("serialisers/serialiser");
var authentication_control_registration_parameters_serialiser_1 = require("./authentication-control-registration-parameters-serialiser");
var authentication_control_registration_request_1 = require("./authentication-control-registration-request");
/**
 * Serialiser for {@link AuthenticationControlRegistrationRequest}
 */
var AuthenticationControlRegistrationRequestSerialiserClass = /** @class */ (function (_super) {
    __extends(AuthenticationControlRegistrationRequestSerialiserClass, _super);
    function AuthenticationControlRegistrationRequestSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link AuthenticationControlRegistrationRequest} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link AuthenticationControlRegistrationRequest} that was read
     */
    AuthenticationControlRegistrationRequestSerialiserClass.prototype.read = function (bis) {
        var params = authentication_control_registration_parameters_serialiser_1.AuthenticationControlRegistrationParametersSerialiser.read(bis);
        var cid = conversation_id_serialiser_1.CIDSerialiser.read(bis);
        return new authentication_control_registration_request_1.AuthenticationControlRegistrationRequest(params, cid);
    };
    /**
     * Write a {@link AuthenticationControlRegistrationRequest} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link AuthenticationControlRegistrationRequest} to be written
     */
    AuthenticationControlRegistrationRequestSerialiserClass.prototype.write = function (bos, value) {
        authentication_control_registration_parameters_serialiser_1.AuthenticationControlRegistrationParametersSerialiser.write(bos, value.params);
        conversation_id_serialiser_1.CIDSerialiser.write(bos, value.cid);
    };
    return AuthenticationControlRegistrationRequestSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.AuthenticationControlRegistrationRequestSerialiserClass = AuthenticationControlRegistrationRequestSerialiserClass;
/**
 * The {@link AuthenticationControlRegistrationRequestSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.AuthenticationControlRegistrationRequestSerialiser = new AuthenticationControlRegistrationRequestSerialiserClass();
