"use strict";
/**
 * @module Services.Security
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var conversation_id_serialiser_1 = require("conversation/conversation-id-serialiser");
var Codec = require("io/codec");
var serialiser_1 = require("serialisers/serialiser");
var CredentialsSerialiser = require("services/authentication/credentials-serialiser");
var SessionDetailsSerialiser = require("services/client/session-details-serialiser");
var authentication_request_1 = require("./authentication-request");
/**
 * Serialiser for {@link AuthenticationRequest}
 */
var AuthenticationRequestSerialiserClass = /** @class */ (function (_super) {
    __extends(AuthenticationRequestSerialiserClass, _super);
    function AuthenticationRequestSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link AuthenticationRequest} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link AuthenticationRequest} that was read
     */
    AuthenticationRequestSerialiserClass.prototype.read = function (bis) {
        var principal = Codec.readString(bis);
        var credentials = CredentialsSerialiser.read(bis);
        var details = SessionDetailsSerialiser.read(bis);
        var cid = conversation_id_serialiser_1.CIDSerialiser.read(bis);
        return new authentication_request_1.AuthenticationRequest(principal, credentials, details, cid);
    };
    return AuthenticationRequestSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.AuthenticationRequestSerialiserClass = AuthenticationRequestSerialiserClass;
/**
 * The {@link AuthenticationRequestSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.AuthenticationRequestSerialiser = new AuthenticationRequestSerialiserClass();
