"use strict";
/**
 * @module Services.Timeseries
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Data type for a TIME_SERIES_EDIT request.
 */
var TimeSeriesEditRequest = /** @class */ (function () {
    /**
     * Create a new TimeSeriesEditRequest instance
     *
     * @param path  the path of the timeseries topic
     * @param dataType  the data type of the new value
     * @param sequence  the sequence number of the event to modify
     * @param value  the new value
     */
    function TimeSeriesEditRequest(path, dataType, sequence, value) {
        this.path = path;
        this.dataType = dataType;
        this.sequence = sequence;
        this.value = value;
    }
    return TimeSeriesEditRequest;
}());
exports.TimeSeriesEditRequest = TimeSeriesEditRequest;
