"use strict";
/**
 * @module Services.UpdateSource
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var conversation_id_serialiser_1 = require("conversation/conversation-id-serialiser");
var Codec = require("io/codec");
var serialiser_1 = require("serialisers/serialiser");
var update_source_delta_request_1 = require("./update-source-delta-request");
/**
 * Serialiser for {@link UpdateSourceDeltaRequest}
 */
var UpdateSourceDeltaRequestSerialiserClass = /** @class */ (function (_super) {
    __extends(UpdateSourceDeltaRequestSerialiserClass, _super);
    function UpdateSourceDeltaRequestSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link UpdateSourceDeltaRequest} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link UpdateSourceDeltaRequest} that was read
     */
    UpdateSourceDeltaRequestSerialiserClass.prototype.read = function (bis) {
        var cid = conversation_id_serialiser_1.CIDSerialiser.read(bis);
        var path = Codec.readString(bis);
        var id = Codec.readInt32(bis);
        var bytes = Codec.readBytes(bis);
        return new update_source_delta_request_1.UpdateSourceDeltaRequest(cid, path, id, bytes);
    };
    /**
     * Write a {@link UpdateSourceDeltaRequest} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link UpdateSourceDeltaRequest} to be written
     */
    UpdateSourceDeltaRequestSerialiserClass.prototype.write = function (bos, value) {
        conversation_id_serialiser_1.CIDSerialiser.write(bos, value.cid);
        Codec.writeString(bos, value.path);
        Codec.writeInt32(bos, value.id);
        Codec.writeBytes(bos, value.bytes);
    };
    return UpdateSourceDeltaRequestSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.UpdateSourceDeltaRequestSerialiserClass = UpdateSourceDeltaRequestSerialiserClass;
/**
 * The {@link UpdateSourceDeltaRequestSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.UpdateSourceDeltaRequestSerialiser = new UpdateSourceDeltaRequestSerialiserClass();
