"use strict";
/**
 * @module Services.UpdateSource
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var conversation_id_serialiser_1 = require("conversation/conversation-id-serialiser");
var serialiser_1 = require("serialisers/serialiser");
var update_source_deregistration_request_1 = require("./update-source-deregistration-request");
/**
 * Serialiser for {@link UpdateSourceDeregistrationRequest}
 */
var UpdateSourceDeregistrationRequestSerialiserClass = /** @class */ (function (_super) {
    __extends(UpdateSourceDeregistrationRequestSerialiserClass, _super);
    function UpdateSourceDeregistrationRequestSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link UpdateSourceDeregistrationRequest} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link UpdateSourceDeregistrationRequest} that was read
     */
    UpdateSourceDeregistrationRequestSerialiserClass.prototype.read = function (bis) {
        var cid = conversation_id_serialiser_1.CIDSerialiser.read(bis);
        return new update_source_deregistration_request_1.UpdateSourceDeregistrationRequest(cid);
    };
    /**
     * Write a {@link UpdateSourceDeregistrationRequest} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link UpdateSourceDeregistrationRequest} to be written
     */
    UpdateSourceDeregistrationRequestSerialiserClass.prototype.write = function (bos, value) {
        conversation_id_serialiser_1.CIDSerialiser.write(bos, value.cid);
    };
    return UpdateSourceDeregistrationRequestSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.UpdateSourceDeregistrationRequestSerialiserClass = UpdateSourceDeregistrationRequestSerialiserClass;
/**
 * The {@link UpdateSourceDeregistrationRequestSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.UpdateSourceDeregistrationRequestSerialiser = new UpdateSourceDeregistrationRequestSerialiserClass();
