"use strict";
/**
 * @module Services.UpdateSource
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var conversation_id_serialiser_1 = require("conversation/conversation-id-serialiser");
var Codec = require("io/codec");
var serialiser_1 = require("serialisers/serialiser");
var update_source_set_request_1 = require("./update-source-set-request");
/**
 * Serialiser for {@link UpdateSourceSetRequest}
 */
var UpdateSourceSetRequestSerialiserClass = /** @class */ (function (_super) {
    __extends(UpdateSourceSetRequestSerialiserClass, _super);
    function UpdateSourceSetRequestSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link UpdateSourceSetRequest} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link UpdateSourceSetRequest} that was read
     */
    UpdateSourceSetRequestSerialiserClass.prototype.read = function (bis) {
        var cid = conversation_id_serialiser_1.CIDSerialiser.read(bis);
        var path = Codec.readString(bis);
        var bytes = Codec.readBytes(bis);
        return new update_source_set_request_1.UpdateSourceSetRequest(cid, path, bytes);
    };
    /**
     * Write a {@link UpdateSourceSetRequest} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link UpdateSourceSetRequest} to be written
     */
    UpdateSourceSetRequestSerialiserClass.prototype.write = function (bos, value) {
        conversation_id_serialiser_1.CIDSerialiser.write(bos, value.cid);
        Codec.writeString(bos, value.path);
        Codec.writeBytes(bos, value.bytes);
    };
    return UpdateSourceSetRequestSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.UpdateSourceSetRequestSerialiserClass = UpdateSourceSetRequestSerialiserClass;
/**
 * The {@link UpdateSourceSetRequestSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.UpdateSourceSetRequestSerialiser = new UpdateSourceSetRequestSerialiserClass();
