"use strict";
/**
 * @module Services.UpdateSource
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var conversation_id_serialiser_1 = require("conversation/conversation-id-serialiser");
var serialiser_1 = require("serialisers/serialiser");
var update_source_state_request_1 = require("./update-source-state-request");
var update_source_state_serialiser_1 = require("./update-source-state-serialiser");
/**
 * Serialiser for {@link UpdateSourceStateRequest}
 */
var UpdateSourceStateRequestSerialiserClass = /** @class */ (function (_super) {
    __extends(UpdateSourceStateRequestSerialiserClass, _super);
    function UpdateSourceStateRequestSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link UpdateSourceStateRequest} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link UpdateSourceStateRequest} that was read
     */
    UpdateSourceStateRequestSerialiserClass.prototype.read = function (bis) {
        var cid = conversation_id_serialiser_1.CIDSerialiser.read(bis);
        var old = update_source_state_serialiser_1.UpdateSourceStateSerialiser.read(bis);
        var current = update_source_state_serialiser_1.UpdateSourceStateSerialiser.read(bis);
        return new update_source_state_request_1.UpdateSourceStateRequest(cid, old.state, current.state);
    };
    return UpdateSourceStateRequestSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.UpdateSourceStateRequestSerialiserClass = UpdateSourceStateRequestSerialiserClass;
/**
 * The {@link UpdateSourceStateRequestSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.UpdateSourceStateRequestSerialiser = new UpdateSourceStateRequestSerialiserClass();
