"use strict";
/**
 * @module Services.UpdateSource
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var update_source_state_1 = require("features/topic-control/update-source-state");
var BEES = require("serialisers/byte-encoded-enum-serialiser");
var serialiser_1 = require("serialisers/serialiser");
var update_source_state_2 = require("./update-source-state");
/**
 * Serialiser for {@link UpdateSourceState}
 */
var UpdateSourceStateSerialiserClass = /** @class */ (function (_super) {
    __extends(UpdateSourceStateSerialiserClass, _super);
    function UpdateSourceStateSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link UpdateSourceState} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link UpdateSourceState} that was read
     */
    UpdateSourceStateSerialiserClass.prototype.read = function (bis) {
        var state = BEES.read(bis, update_source_state_1.UpdateSourceState);
        return new update_source_state_2.UpdateSourceState(state);
    };
    return UpdateSourceStateSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.UpdateSourceStateSerialiserClass = UpdateSourceStateSerialiserClass;
/**
 * The {@link UpdateSourceStateSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.UpdateSourceStateSerialiser = new UpdateSourceStateSerialiserClass();
