"use strict";
/**
 * @module Services.UpdateSource
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BEES = require("serialisers/byte-encoded-enum-serialiser");
var serialiser_1 = require("serialisers/serialiser");
var update_source_update_response_1 = require("./update-source-update-response");
/**
 * Serialiser for {@link UpdateSourceUpdateResponse}
 */
var UpdateSourceUpdateResponseSerialiserClass = /** @class */ (function (_super) {
    __extends(UpdateSourceUpdateResponseSerialiserClass, _super);
    function UpdateSourceUpdateResponseSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link UpdateSourceUpdateResponse} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link UpdateSourceUpdateResponse} that was read
     */
    UpdateSourceUpdateResponseSerialiserClass.prototype.read = function (bis) {
        var error = BEES.read(bis, update_source_update_response_1.ResponseCode);
        return new update_source_update_response_1.UpdateSourceUpdateResponse(error === update_source_update_response_1.ResponseCode.SUCCESS ? null : error);
    };
    return UpdateSourceUpdateResponseSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.UpdateSourceUpdateResponseSerialiserClass = UpdateSourceUpdateResponseSerialiserClass;
/**
 * The {@link UpdateSourceUpdateResponseSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.UpdateSourceUpdateResponseSerialiser = new UpdateSourceUpdateResponseSerialiserClass();
