"use strict";
/**
 * @module Services.UpdateTopic
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Codec = require("io/codec");
var serialiser_1 = require("serialisers/serialiser");
var update_topic_set_request_1 = require("./update-topic-set-request");
/**
 * Serialiser for {@link UpdateTopicSetRequest}
 */
var UpdateTopicSetRequestSerialiserClass = /** @class */ (function (_super) {
    __extends(UpdateTopicSetRequestSerialiserClass, _super);
    function UpdateTopicSetRequestSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link UpdateTopicSetRequest} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link UpdateTopicSetRequest} that was read
     */
    UpdateTopicSetRequestSerialiserClass.prototype.read = function (bis) {
        var path = Codec.readString(bis);
        var bytes = Codec.readBytes(bis);
        return new update_topic_set_request_1.UpdateTopicSetRequest(path, bytes);
    };
    /**
     * Write a {@link UpdateTopicSetRequest} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link UpdateTopicSetRequest} to be written
     */
    UpdateTopicSetRequestSerialiserClass.prototype.write = function (bos, value) {
        Codec.writeString(bos, value.path);
        Codec.writeBytes(bos, value.bytes);
    };
    return UpdateTopicSetRequestSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.UpdateTopicSetRequestSerialiserClass = UpdateTopicSetRequestSerialiserClass;
/**
 * The {@link UpdateTopicSetRequestSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.UpdateTopicSetRequestSerialiser = new UpdateTopicSetRequestSerialiserClass();
