"use strict";
/**
 * @module Services.Wills
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Codec = require("io/codec");
var BEES = require("serialisers/byte-encoded-enum-serialiser");
var serialiser_1 = require("serialisers/serialiser");
var topic_will_parameters_1 = require("./topic-will-parameters");
/**
 * Serialiser for {@link TopicWillParameters}
 */
var TopicWillParametersSerialiserClass = /** @class */ (function (_super) {
    __extends(TopicWillParametersSerialiserClass, _super);
    function TopicWillParametersSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link TopicWillParameters} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link TopicWillParameters} that was read
     */
    TopicWillParametersSerialiserClass.prototype.read = function (bis) {
        var path = Codec.readString(bis);
        var will = BEES.read(bis, topic_will_parameters_1.Will);
        return new topic_will_parameters_1.TopicWillParameters(path, will);
    };
    /**
     * Write a {@link TopicWillParameters} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link TopicWillParameters} to be written
     */
    TopicWillParametersSerialiserClass.prototype.write = function (bos, value) {
        Codec.writeString(bos, value.path);
        BEES.write(bos, value.will);
    };
    return TopicWillParametersSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.TopicWillParametersSerialiserClass = TopicWillParametersSerialiserClass;
/**
 * The {@link TopicWillParametersSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.TopicWillParametersSerialiser = new TopicWillParametersSerialiserClass();
