"use strict";
/**
 * @module Services.Wills
 */
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * A topic will
 */
var Will;
(function (Will) {
    Will[Will["REMOVE_TOPICS"] = 0] = "REMOVE_TOPICS";
})(Will = exports.Will || (exports.Will = {}));
/**
 * Data type for a TOPIC_SCOPED_WILL_REGISTRATION or TOPIC_SCOPED_WILL_DEREGISTRATION request.
 */
var TopicWillParameters = /** @class */ (function () {
    /**
     * Create a new TopicWillParameters instance
     *
     * @param path the topic path
     * @param will what to do when the session dies
     */
    function TopicWillParameters(path, will) {
        this.path = path;
        this.will = will;
    }
    return TopicWillParameters;
}());
exports.TopicWillParameters = TopicWillParameters;
