"use strict";
/**
 * @module Services.Wills
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var BEES = require("serialisers/byte-encoded-enum-serialiser");
var serialiser_1 = require("serialisers/serialiser");
var will_registration_result_1 = require("./will-registration-result");
/**
 * Serialiser for {@link WillRegistrationResult}
 */
var WillRegistrationResultSerialiserClass = /** @class */ (function (_super) {
    __extends(WillRegistrationResultSerialiserClass, _super);
    function WillRegistrationResultSerialiserClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Read a {@link WillRegistrationResult} from the stream
     *
     * @param bis  the input stream
     * @return     the {@link WillRegistrationResult} that was read
     */
    WillRegistrationResultSerialiserClass.prototype.read = function (bis) {
        var result = BEES.read(bis, will_registration_result_1.WillRegistrationResultEnum);
        return new will_registration_result_1.WillRegistrationResult(result);
    };
    /**
     * Write a {@link WillRegistrationResult} to the stream
     *
     * @param bos    the output stream
     * @param value  the {@link WillRegistrationResult} to be written
     */
    WillRegistrationResultSerialiserClass.prototype.write = function (bos, value) {
        BEES.write(bos, value.result);
    };
    return WillRegistrationResultSerialiserClass;
}(serialiser_1.AbstractSerialiser));
exports.WillRegistrationResultSerialiserClass = WillRegistrationResultSerialiserClass;
/**
 * The {@link WillRegistrationResultSerialiser} singleton
 */ // tslint:disable-next-line:variable-name
exports.WillRegistrationResultSerialiser = new WillRegistrationResultSerialiserClass();
